--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_xioctl.c	Mon Aug  5 17:28:45 2019
@@ -4793,15 +4932,15 @@
 			EL(ha, "flash desc table ok, exit\n");
 			return (rval);
 		}
-		if (CFG_IST(ha, CFG_CTRL_8021)) {
-			xp->fdesc.flash_manuf = WINBOND_FLASH;
-			xp->fdesc.flash_id = WINBOND_FLASHID;
+		if (CFG_IST(ha, CFG_CTRL_82XX)) {
+			xp->fdesc.flash_manuf = MXIC_FLASH;
+			xp->fdesc.flash_id = MXIC_FLASHID_25LXX;
 			xp->fdesc.flash_len = 0x17;
 		} else {
 			(void) ql_24xx_flash_id(ha);
 		}
 
-	} else if (CFG_IST(ha, CFG_CTRL_2422)) {
+	} else if (CFG_IST(ha, CFG_CTRL_24XX)) {
 		(void) ql_24xx_flash_id(ha);
 	} else {
 		ql_flash_enable(ha);
@@ -4837,7 +4976,7 @@
 	xp->fdesc.write_enable_bits = 0;
 	xp->fdesc.unprotect_sector_cmd = 0;
 	xp->fdesc.protect_sector_cmd = 0;
-	xp->fdesc.write_disable_bits = 0x9c;
+	xp->fdesc.write_disable_bits = 0xbc;
 	xp->fdesc.block_size = 0x10000;
 	xp->fdesc.erase_cmd = 0xd8;
 
@@ -4844,6 +4983,13 @@
 	switch (xp->fdesc.flash_manuf) {
 	case AMD_FLASH:
 		switch (xp->fdesc.flash_id) {
+		case SPAN_FLASHID_16384K:
+			if (xp->fdesc.flash_len == 0x18) {
+				xp->fdesc.flash_size = 0x1000000;
+			} else {
+				rval = QL_FUNCTION_FAILED;
+			}
+			break;
 		case SPAN_FLASHID_2048K:
 			xp->fdesc.flash_size = 0x200000;
 			break;
@@ -4884,6 +5030,13 @@
 				rval = QL_FUNCTION_FAILED;
 			}
 			break;
+		case ST_FLASHID_N25QXXX:
+			if (xp->fdesc.flash_len == 0x18) {
+				xp->fdesc.flash_size = 0x1000000;
+			} else {
+				rval = QL_FUNCTION_FAILED;
+			}
+			break;
 		default:
 			rval = QL_FUNCTION_FAILED;
 			break;
@@ -4920,10 +5073,17 @@
 			xp->fdesc.flash_size = 0x100000;
 			break;
 		case MXIC_FLASHID_25LXX:
+			xp->fdesc.write_disable_bits = 0xbc;
 			if (xp->fdesc.flash_len == 0x14) {
 				xp->fdesc.flash_size = 0x100000;
 			} else if (xp->fdesc.flash_len == 0x15) {
 				xp->fdesc.flash_size = 0x200000;
+			} else if (xp->fdesc.flash_len == 0x16) {
+				xp->fdesc.flash_size = 0x400000;
+			} else if (xp->fdesc.flash_len == 0x17) {
+				xp->fdesc.flash_size = 0x800000;
+			} else if (xp->fdesc.flash_len == 0x18) {
+				xp->fdesc.flash_size = 0x1000000;
 			} else {
 				rval = QL_FUNCTION_FAILED;
 			}
@@ -4955,6 +5115,8 @@
 				xp->fdesc.flash_size = 0x400000;
 			} else if (xp->fdesc.flash_len == 0x17) {
 				xp->fdesc.flash_size = 0x800000;
+			} else if (xp->fdesc.flash_len == 0x18) {
+				xp->fdesc.flash_size = 0x1000000;
 			} else {
 				rval = QL_FUNCTION_FAILED;
 			}
@@ -4982,6 +5144,20 @@
 			break;
 		}
 		break;
+	case EON_FLASH:
+		switch (xp->fdesc.flash_id) {
+		case EON_FLASHID_EN25QXXX:
+			if (xp->fdesc.flash_len == 0x18) {
+				xp->fdesc.flash_size = 0x1000000;
+			} else {
+				rval = QL_FUNCTION_FAILED;
+			}
+			break;
+		default:
+			rval = QL_FUNCTION_FAILED;
+			break;
+		}
+		break;
 	default:
 		rval = QL_FUNCTION_FAILED;
 		break;
@@ -4988,20 +5164,20 @@
 	}
 
 	/* Try flash table later. */
-	if (rval != QL_SUCCESS && CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (rval != QL_SUCCESS && CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		EL(ha, "no default id\n");
 		return (QL_SUCCESS);
 	}
 
 	/*
-	 * hack for non std 2312 and 6312 boards. hardware people need to
-	 * use either the 128k flash chip (original), or something larger.
-	 * For driver purposes, we'll treat it as a 128k flash chip.
+	 * hack for non std 2312/2322 and 6312/6322 boards. hardware people
+	 * need to use either the 128k flash chip (original), or something
+	 * larger. For driver purposes, we'll treat it as a 128k flash chip.
 	 */
 	if ((ha->device_id == 0x2312 || ha->device_id == 0x6312 ||
 	    ha->device_id == 0x2322 || ha->device_id == 0x6322) &&
 	    (xp->fdesc.flash_size > 0x20000) &&
-	    (CFG_IST(ha, CFG_SBUS_CARD) ==  0)) {
+	    (CFG_IST(ha, CFG_SBUS_CARD) == 0)) {
 		EL(ha, "chip exceeds max size: %xh, using 128k\n",
 		    xp->fdesc.flash_size);
 		xp->fdesc.flash_size = 0x20000;
@@ -5042,7 +5218,7 @@
 	ql_xioctl_t	*xp = ha->xioctl;
 	int		rval = 0;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (bsize > xp->fdesc.flash_size) {
 		EL(ha, "failed, bufsize: %xh, flash size: %xh\n", bsize,
@@ -5053,7 +5229,7 @@
 	if ((bfp = (uint8_t *)kmem_zalloc(bsize, KM_SLEEP)) == NULL) {
 		EL(ha, "failed, kmem_zalloc\n");
 		rval = ENOMEM;
-	} else  {
+	} else {
 		if (ddi_copyin(bp, bfp, bsize, mode) != 0) {
 			EL(ha, "failed, ddi_copyin\n");
 			rval = EFAULT;
@@ -5068,7 +5244,7 @@
 		kmem_free(bfp, bsize);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -5095,11 +5271,11 @@
 	uint32_t	cnt;
 	int		rval;
 
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		return (ql_24xx_load_flash(ha, dp, size, addr));
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (CFG_IST(ha, CFG_SBUS_CARD)) {
 		/*
@@ -5141,7 +5317,7 @@
 		EL(ha, "failed, rval=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 	return (rval);
 }
@@ -5170,7 +5346,7 @@
 	int		rval;
 	ql_xioctl_t	*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* adjust max read size to flash size */
 	if (bsize > xp->fdesc.flash_size) {
@@ -5198,7 +5374,7 @@
 		kmem_free(bfp, bsize);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -5229,7 +5405,7 @@
 	int		fp_rval, rval = QL_SUCCESS;
 	dma_mem_t	mem;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* make sure startpos+size doesn't exceed flash */
 	if (size + startpos > ha->xioctl->fdesc.flash_size) {
@@ -5238,7 +5414,7 @@
 		return (QL_FUNCTION_PARAMETER_ERROR);
 	}
 
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		/* check start addr is 32 bit aligned for 24xx */
 		if ((startpos & 0x3) != 0) {
 			rval = ql_24xx_read_flash(ha,
@@ -5257,7 +5433,7 @@
 				size--;
 			}
 			if (size == 0) {
-				QL_PRINT_9(CE_CONT, "(%d): done2\n",
+				QL_PRINT_9(ha, "done2\n",
 				    ha->instance);
 				return (rval);
 			}
@@ -5270,7 +5446,7 @@
 	bzero(&mem, sizeof (dma_mem_t));
 	/* Check for Fast page is supported */
 	if ((ha->pha->task_daemon_flags & FIRMWARE_UP) &&
-	    (CFG_IST(ha, CFG_CTRL_2581))) {
+	    (CFG_IST(ha, CFG_FLASH_DMA_SUPPORT))) {
 		fp_rval = QL_SUCCESS;
 		/* Setup DMA buffer. */
 		rval = ql_get_dma_mem(ha, &mem, size,
@@ -5287,7 +5463,7 @@
 	GLOBAL_HW_LOCK();
 
 	/* Enable Flash Read/Write. */
-	if (CFG_IST(ha, CFG_CTRL_24258081) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		ql_flash_enable(ha);
 	}
 
@@ -5295,9 +5471,9 @@
 	while (size) {
 		/* Allow other system activity. */
 		if (size % 0x1000 == 0) {
-			ql_delay(ha, 100000);
+			ql_delay(ha, 10000);
 		}
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			if (fp_rval == QL_SUCCESS && (addr & 0x3f) == 0) {
 				cnt = (size + 3) >> 2;
 				fp_rval = ql_rd_risc_ram(ha, addr,
@@ -5328,7 +5504,7 @@
 		}
 	}
 
-	if (CFG_IST(ha, CFG_CTRL_24258081) == 0) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_1)) {
 		ql_flash_disable(ha);
 	}
 
@@ -5342,7 +5518,7 @@
 		EL(ha, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 	return (rval);
 }
@@ -5404,7 +5580,7 @@
 	EXT_RNID_DATA		*tmp_buf;
 	int			rval = 0;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (DRIVER_SUSPENDED(ha)) {
 		EL(ha, "failed, LOOP_NOT_READY\n");
@@ -5469,7 +5645,7 @@
 
 	kmem_free(tmp_buf, sizeof (EXT_RNID_DATA));
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -5487,7 +5663,7 @@
 	EXT_RNID_DATA	*tmp_buf;
 	uint32_t	rval;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (DRIVER_SUSPENDED(ha)) {
 		EL(ha, "failed, LOOP_NOT_READY\n");
@@ -5525,7 +5701,7 @@
 		cmd->Status = EXT_STATUS_COPY_ERR;
 		cmd->ResponseLen = 0;
 	} else {
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 		cmd->ResponseLen = sizeof (EXT_RNID_DATA);
 	}
 
@@ -5552,7 +5728,7 @@
 	ql_xioctl_t		*xp = ha->xioctl;
 	int			rval = 0;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (DRIVER_SUSPENDED(ha)) {
 		EL(ha, "failed, LOOP_NOT_READY\n");
@@ -5588,7 +5764,7 @@
 	xp->TotalInterrupts = 0;
 	INTR_UNLOCK(ha);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -5617,7 +5793,7 @@
 	ql_xioctl_t		*xp = ha->xioctl;
 	int			retry = 10;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	while (ha->task_daemon_flags &
 	    (ABORT_ISP_ACTIVE | LOOP_RESYNC_ACTIVE | DRIVER_STALL)) {
@@ -5685,7 +5861,7 @@
 
 	kmem_free(ls, sizeof (ql_link_stats_t));
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -5715,7 +5891,7 @@
 	ql_tgt_t		*tq = NULL;
 	int			retry = 10;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (ddi_copyin((void *)(uintptr_t)cmd->RequestAdr,
 	    (void *)&pextdestaddr, sizeof (EXT_DEST_ADDR), mode) != 0) {
@@ -5728,7 +5904,7 @@
 	qlnt = QLNT_PORT;
 	name = pextdestaddr.DestAddr.WWPN;
 
-	QL_PRINT_9(CE_CONT, "(%d): wwpn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
+	QL_PRINT_9(ha, "wwpn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
 	    ha->instance, name[0], name[1], name[2], name[3], name[4],
 	    name[5], name[6], name[7]);
 
@@ -5742,7 +5918,7 @@
 	}
 
 	while (ha->task_daemon_flags &
-	    (ABORT_ISP_ACTIVE | LOOP_RESYNC_ACTIVE  | DRIVER_STALL)) {
+	    (ABORT_ISP_ACTIVE | LOOP_RESYNC_ACTIVE | DRIVER_STALL)) {
 		ql_delay(ha, 10000000);	/* 10 second delay */
 
 		retry--;
@@ -5795,7 +5971,7 @@
 
 	kmem_free(ls, sizeof (ql_link_stats_t));
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -5820,7 +5996,7 @@
 	EXT_HBA_FC4STATISTICS	fc4stats = {0};
 	ql_xioctl_t		*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	fc4stats.InputRequests = xp->IOInputRequests;
 	fc4stats.OutputRequests = xp->IOOutputRequests;
@@ -5840,7 +6016,7 @@
 		cmd->ResponseLen = sizeof (EXT_HBA_FC4STATISTICS);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -5862,10 +6038,10 @@
 ql_set_led_state(ql_adapter_state_t *ha, EXT_IOCTL *cmd, int mode)
 {
 	EXT_BEACON_CONTROL	bstate;
-	uint32_t		rval;
-	ql_xioctl_t		*xp = ha->xioctl;
+	int			rval;
+	ql_mbx_data_t		mr;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->RequestLen < sizeof (EXT_BEACON_CONTROL)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -5876,7 +6052,7 @@
 		return;
 	}
 
-	if (ha->device_id < 0x2300) {
+	if (!CFG_IST(ha, CFG_SET_LEDS_SUPPORT)) {
 		cmd->Status = EXT_STATUS_UNSUPPORTED_SUBCODE;
 		cmd->DetailStatus = 0;
 		EL(ha, "done - failed, Invalid function for HBA model\n");
@@ -5895,7 +6071,7 @@
 
 	switch (bstate.State) {
 	case EXT_DEF_GRN_BLINK_OFF:	/* turn beacon off */
-		if (xp->ledstate.BeaconState == BEACON_OFF) {
+		if (ha->ledstate.BeaconState == BEACON_OFF) {
 			/* not quite an error -- LED state is already off */
 			cmd->Status = EXT_STATUS_OK;
 			EL(ha, "LED off request -- LED is already off\n");
@@ -5902,9 +6078,25 @@
 			break;
 		}
 
-		xp->ledstate.BeaconState = BEACON_OFF;
-		xp->ledstate.LEDflags = LED_ALL_OFF;
+		if (CFG_IST(ha, CFG_CTRL_82XX)) {
+			rval = ql_diag_beacon(ha, QL_BEACON_DISABLE,
+			    &mr);
 
+			if (rval == QL_SUCCESS) {
+				ha->ledstate.BeaconState = BEACON_OFF;
+				ha->ledstate.LEDflags = LED_ALL_OFF;
+				cmd->Status = EXT_STATUS_OK;
+			} else {
+				cmd->Status = EXT_STATUS_ERR;
+				EL(ha, "failed, disable beacon request %xh\n",
+				    bstate.State);
+			}
+			break;
+		}
+
+		ha->ledstate.BeaconState = BEACON_OFF;
+		ha->ledstate.LEDflags = LED_ALL_OFF;
+
 		if ((rval = ql_wrapup_led(ha)) != QL_SUCCESS) {
 			cmd->Status = EXT_STATUS_MAILBOX;
 		} else {
@@ -5913,7 +6105,7 @@
 		break;
 
 	case EXT_DEF_GRN_BLINK_ON:	/* turn beacon on */
-		if (xp->ledstate.BeaconState == BEACON_ON) {
+		if (ha->ledstate.BeaconState == BEACON_ON) {
 			/* not quite an error -- LED state is already on */
 			cmd->Status = EXT_STATUS_OK;
 			EL(ha, "LED on request  - LED is already on\n");
@@ -5920,17 +6112,33 @@
 			break;
 		}
 
+		if (CFG_IST(ha, CFG_CTRL_82XX)) {
+			rval = ql_diag_beacon(ha, QL_BEACON_ENABLE,
+			    &mr);
+
+			if (rval == QL_SUCCESS) {
+				ha->ledstate.BeaconState = BEACON_ON;
+				ha->ledstate.LEDflags = LED_GREEN;
+				cmd->Status = EXT_STATUS_OK;
+			} else {
+				cmd->Status = EXT_STATUS_ERR;
+				EL(ha, "failed, enable beacon request %xh\n",
+				    bstate.State);
+			}
+			break;
+		}
+
 		if ((rval = ql_setup_led(ha)) != QL_SUCCESS) {
 			cmd->Status = EXT_STATUS_MAILBOX;
 			break;
 		}
 
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
-			xp->ledstate.LEDflags = LED_YELLOW_24 | LED_AMBER_24;
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
+			ha->ledstate.LEDflags = LED_YELLOW_24 | LED_AMBER_24;
 		} else {
-			xp->ledstate.LEDflags = LED_GREEN;
+			ha->ledstate.LEDflags = LED_GREEN;
 		}
-		xp->ledstate.BeaconState = BEACON_ON;
+		ha->ledstate.BeaconState = BEACON_ON;
 
 		cmd->Status = EXT_STATUS_OK;
 		break;
@@ -5940,7 +6148,7 @@
 		break;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -5963,9 +6171,8 @@
 {
 	EXT_BEACON_CONTROL	bstate = {0};
 	uint32_t		rval;
-	ql_xioctl_t		*xp = ha->xioctl;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (cmd->ResponseLen < sizeof (EXT_BEACON_CONTROL)) {
 		cmd->Status = EXT_STATUS_BUFFER_TOO_SMALL;
@@ -5976,7 +6183,7 @@
 		return;
 	}
 
-	if (ha->device_id < 0x2300) {
+	if (!CFG_IST(ha, CFG_SET_LEDS_SUPPORT)) {
 		cmd->Status = EXT_STATUS_UNSUPPORTED_SUBCODE;
 		cmd->DetailStatus = 0;
 		EL(ha, "done - failed, Invalid function for HBA model\n");
@@ -5992,7 +6199,7 @@
 	}
 
 	/* inform the user of the current beacon state (off or on) */
-	bstate.State = xp->ledstate.BeaconState;
+	bstate.State = ha->ledstate.BeaconState;
 
 	rval = ddi_copyout((void *)&bstate,
 	    (void *)(uintptr_t)cmd->ResponseAdr,
@@ -6007,7 +6214,7 @@
 		cmd->ResponseLen = sizeof (EXT_BEACON_CONTROL);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -6023,26 +6230,79 @@
 void
 ql_blink_led(ql_adapter_state_t *ha)
 {
-	uint32_t		nextstate;
-	ql_xioctl_t		*xp = ha->xioctl;
+	uint32_t	nextstate;
+	ql_mbx_data_t	mr;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	if (xp->ledstate.BeaconState == BEACON_ON) {
-		/* determine the next led state */
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
-			nextstate = (xp->ledstate.LEDflags) &
-			    (~(RD32_IO_REG(ha, gpiod)));
-		} else {
-			nextstate = (xp->ledstate.LEDflags) &
-			    (~(RD16_IO_REG(ha, gpiod)));
-		}
+	if (ha->ledstate.BeaconState == BEACON_ON) {
+		if (CFG_IST(ha, CFG_CTRL_2363 | CFG_CTRL_2425)) {
+			/* determine the next led state */
+			if (CFG_IST(ha, CFG_CTRL_2425)) {
+				nextstate = (ha->ledstate.LEDflags) &
+				    (~(RD32_IO_REG(ha, gpiod)));
+			} else {
+				nextstate = (ha->ledstate.LEDflags) &
+				    (~(RD16_IO_REG(ha, gpiod)));
+			}
 
-		/* turn the led on or off */
-		ql_drive_led(ha, nextstate);
+			/* turn the led on or off */
+			ql_drive_led(ha, nextstate);
+		} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
+			if (ha->ledstate.flags & LED_ACTIVE) {
+				mr.mb[1] = 0x2000;
+				mr.mb[2] = 0x4000;
+				ha->ledstate.flags &= ~LED_ACTIVE;
+			} else {
+				mr.mb[1] = 0x4000;
+				mr.mb[2] = 0x2000;
+				ha->ledstate.flags |= LED_ACTIVE;
+			}
+			(void) ql_set_led_config(ha, &mr);
+		} else if (CFG_IST(ha, CFG_CTRL_80XX)) {
+			if (ha->ledstate.flags & LED_ACTIVE) {
+				mr.mb[1] = 0x4000;
+				mr.mb[2] = 0x2000;
+				mr.mb[3] = 0x4000;
+				mr.mb[4] = 0x4000;
+				mr.mb[5] = 0;
+				mr.mb[6] = 0x2000;
+				(void) ql_set_led_config(ha, &mr);
+				ha->ledstate.flags &= ~LED_ACTIVE;
+			} else {
+				mr.mb[1] = 0x4000;
+				mr.mb[2] = 0x4000;
+				mr.mb[3] = 0x4000;
+				mr.mb[4] = 0x2000;
+				mr.mb[5] = 0;
+				mr.mb[6] = 0x2000;
+				(void) ql_set_led_config(ha, &mr);
+				ha->ledstate.flags |= LED_ACTIVE;
+			}
+		} else if (CFG_IST(ha, CFG_CTRL_83XX)) {
+			if (ha->ledstate.flags & LED_ACTIVE) {
+				(void) ql_write_remote_reg(ha,
+				    ha->ledstate.select,
+				    0x40004000);
+				(void) ql_write_remote_reg(ha,
+				    ha->ledstate.select + 4,
+				    0x40004000);
+				ha->ledstate.flags &= ~LED_ACTIVE;
+			} else {
+				(void) ql_write_remote_reg(ha,
+				    ha->ledstate.select,
+				    0x40002000);
+				(void) ql_write_remote_reg(ha,
+				    ha->ledstate.select + 4,
+				    0x40002000);
+				ha->ledstate.flags |= LED_ACTIVE;
+			}
+		} else if (!CFG_IST(ha, CFG_CTRL_27XX)) {
+			EL(ha, "unsupported HBA: %xh\n", ha->device_id);
+		}
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -6059,11 +6319,10 @@
 static void
 ql_drive_led(ql_adapter_state_t *ha, uint32_t LEDflags)
 {
+	QL_PRINT_9(ha, "started\n");
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	if (CFG_IST(ha, CFG_CTRL_2363)) {
 
-	if (CFG_IST(ha, (CFG_CTRL_2300 | CFG_CTRL_6322))) {
-
 		uint16_t	gpio_enable, gpio_data;
 
 		/* setup to send new data */
@@ -6081,8 +6340,7 @@
 		/* write out the new led data */
 		WRT16_IO_REG(ha, gpiod, gpio_data);
 
-	} else if (CFG_IST(ha, CFG_CTRL_24258081)) {
-
+	} else if (CFG_IST(ha, CFG_CTRL_2425)) {
 		uint32_t	gpio_data;
 
 		/* setup to send new data */
@@ -6101,10 +6359,10 @@
 		WRT32_IO_REG(ha, gpiod, gpio_data);
 
 	} else {
-		EL(ha, "unsupported HBA: %xh", ha->device_id);
+		EL(ha, "unsupported HBA: %xh\n", ha->device_id);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -6117,36 +6375,108 @@
  * Context:
  *	Kernel/Interrupt context.
  */
-static uint32_t
+static int
 ql_setup_led(ql_adapter_state_t *ha)
 {
-	uint32_t	rval;
+	int		rval = QL_SUCCESS;
 	ql_mbx_data_t	mr;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	/* decouple the LED control from the fw */
-	rval = ql_get_firmware_option(ha, &mr);
-	if (rval != QL_SUCCESS) {
-		EL(ha, "failed, get_firmware_option=%xh\n", rval);
-		return (rval);
-	}
+	if (CFG_IST(ha, CFG_CTRL_2363 | CFG_CTRL_2425)) {
+		/* decouple the LED control from the fw */
+		rval = ql_get_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, get_firmware_option=%xh\n", rval);
+			return (rval);
+		}
 
-	/* set the appropriate options */
-	mr.mb[1] = (uint16_t)(mr.mb[1] | FO1_DISABLE_GPIO);
+		/* set the appropriate options */
+		mr.mb[1] = (uint16_t)(mr.mb[1] | FO1_DISABLE_GPIO);
 
-	/* send it back to the firmware */
-	rval = ql_set_firmware_option(ha, &mr);
-	if (rval != QL_SUCCESS) {
-		EL(ha, "failed, set_firmware_option=%xh\n", rval);
-		return (rval);
-	}
+		/* send it back to the firmware */
+		rval = ql_set_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, set_firmware_option=%xh\n", rval);
+			return (rval);
+		}
 
-	/* initally, turn the LED's off */
-	ql_drive_led(ha, LED_ALL_OFF);
+		/* initally, turn the LED's off */
+		ql_drive_led(ha, LED_ALL_OFF);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	} else if (CFG_IST(ha, CFG_CTRL_81XX)) {
+		(void) ql_get_led_config(ha, &ha->ledstate.cfg);
+		mr.mb[1] = 0x2000;
+		mr.mb[2] = 0x2000;
+		rval = ql_set_led_config(ha, &mr);
 
+	} else if (CFG_IST(ha, CFG_CTRL_80XX)) {
+		/* Save initial value */
+		rval = ql_get_led_config(ha, &ha->ledstate.cfg);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, get_led_config=%xh\n", rval);
+			return (rval);
+		}
+		mr.mb[1] = 0x4000;
+		mr.mb[2] = 0x4000;
+		mr.mb[3] = 0x4000;
+		mr.mb[4] = 0x2000;
+		mr.mb[5] = 0;
+		mr.mb[6] = 0x2000;
+		rval = ql_set_led_config(ha, &mr);
+
+	} else if (CFG_IST(ha, CFG_CTRL_83XX)) {
+		rval = ql_get_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, get_firmware_option=%xh\n", rval);
+			return (rval);
+		}
+
+		mr.mb[1] = (uint16_t)(mr.mb[1] | FO1_DISABLE_LEDS);
+
+		rval = ql_set_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, set_firmware_option=%xh\n", rval);
+			return (rval);
+		}
+
+		(void) ql_write_remote_reg(ha, ha->ledstate.select,
+		    0x40002000);
+		(void) ql_write_remote_reg(ha, ha->ledstate.select + 4,
+		    0x40002000);
+
+	} else if (CFG_IST(ha, CFG_CTRL_27XX)) {
+		/* take control of LED */
+		rval = ql_get_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, get_firmware_option=%xh\n", rval);
+			return (rval);
+		}
+
+		mr.mb[1] = (uint16_t)(mr.mb[1] | FO1_DISABLE_LEDS);
+
+		rval = ql_set_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, set_firmware_option=%xh\n", rval);
+			return (rval);
+		}
+
+		mr.mb[1] = 0xf;
+		mr.mb[2] = 0x230;
+		mr.mb[3] = 0x230;
+		mr.mb[4] = 0x4000;
+		rval = ql_led_config(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, led_config=%xh\n", rval);
+			return (rval);
+		}
+	} else {
+		EL(ha, "unsupported HBA: %xh\n", ha->device_id);
+	}
+	ha->ledstate.flags |= LED_ACTIVE;
+
+	QL_PRINT_9(ha, "done\n");
+
 	return (rval);
 }
 
@@ -6160,45 +6490,67 @@
  * Context:
  *	Kernel/Interrupt context.
  */
-static uint32_t
+static int
 ql_wrapup_led(ql_adapter_state_t *ha)
 {
-	uint32_t	rval;
+	int		rval = QL_SUCCESS;
 	ql_mbx_data_t	mr;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
-	/* Turn all LED's off */
-	ql_drive_led(ha, LED_ALL_OFF);
 
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
-
+	if (CFG_IST(ha, CFG_CTRL_2363 | CFG_CTRL_2425)) {
 		uint32_t	gpio_data;
 
-		/* disable the LED update mask */
-		gpio_data = RD32_IO_REG(ha, gpiod);
-		gpio_data &= ~LED_MASK_UPDATE_24;
+		/* Turn all LED's off */
+		ql_drive_led(ha, LED_ALL_OFF);
 
-		/* write out the data */
-		WRT32_IO_REG(ha, gpiod, gpio_data);
-	}
+		if (CFG_IST(ha, CFG_CTRL_2425)) {
+			/* disable the LED update mask */
+			gpio_data = RD32_IO_REG(ha, gpiod);
+			gpio_data &= ~LED_MASK_UPDATE_24;
 
-	/* give LED control back to the f/w */
-	rval = ql_get_firmware_option(ha, &mr);
-	if (rval != QL_SUCCESS) {
-		EL(ha, "failed, get_firmware_option=%xh\n", rval);
-		return (rval);
-	}
+			/* write out the data */
+			WRT32_IO_REG(ha, gpiod, gpio_data);
+			/* give LED control back to the f/w */
+		}
+		rval = ql_get_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, get_firmware_option=%xh\n", rval);
+			return (rval);
+		}
 
-	mr.mb[1] = (uint16_t)(mr.mb[1] & ~FO1_DISABLE_GPIO);
+		mr.mb[1] = (uint16_t)(mr.mb[1] & ~FO1_DISABLE_GPIO);
 
-	rval = ql_set_firmware_option(ha, &mr);
-	if (rval != QL_SUCCESS) {
-		EL(ha, "failed, set_firmware_option=%xh\n", rval);
-		return (rval);
+		rval = ql_set_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, set_firmware_option=%xh\n", rval);
+			return (rval);
+		}
+	} else if (CFG_IST(ha, CFG_CTRL_8081)) {
+		rval = ql_set_led_config(ha, &ha->ledstate.cfg);
+
+	} else if (CFG_IST(ha, CFG_CTRL_2783)) {
+		/* give LED control back to the f/w */
+		rval = ql_get_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, get_firmware_option=%xh\n", rval);
+			return (rval);
+		}
+
+		mr.mb[1] = (uint16_t)(mr.mb[1] & ~FO1_DISABLE_LEDS);
+
+		rval = ql_set_firmware_option(ha, &mr);
+		if (rval != QL_SUCCESS) {
+			EL(ha, "failed, set_firmware_option=%xh\n", rval);
+			return (rval);
+		}
+
+	} else {
+		EL(ha, "unsupported HBA: %xh\n", ha->device_id);
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 
 	return (rval);
 }
@@ -6232,7 +6584,7 @@
 	int			rval = 0;
 	EXT_DEVICEDATAENTRY	*uddep, *ddep;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	ddep = &dd.EntryList[0];
 
@@ -6291,7 +6643,8 @@
 		    link = link->next) {
 			tq = link->base_address;
 			if (tq->flags & TQF_INITIATOR_DEVICE ||
-			    !VALID_TARGET_ID(ha, tq->loop_id)) {
+			    !VALID_TARGET_ID(ha, tq->loop_id) ||
+			    tq->d_id.b24 == FS_MANAGEMENT_SERVER) {
 				continue;	/* Skip this one */
 			}
 
@@ -6309,7 +6662,7 @@
 
 			ddep->DeviceFlags = tq->flags;
 			ddep->LoopID = tq->loop_id;
-			QL_PRINT_9(CE_CONT, "(%d): Tgt=%lld, loop=%xh, "
+			QL_PRINT_9(ha, "Tgt=%lld, loop=%xh, "
 			    "wwnn=%02x%02x%02x%02x%02x%02x%02x%02x, "
 			    "wwpn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
 			    ha->instance, ddep->TargetAddress.Target,
@@ -6345,7 +6698,7 @@
 		EL(ha, "failed, ddi_copyout-2\n");
 	} else {
 		cmd->ResponseLen += (uint32_t)sizeof (EXT_DEVICEDATAENTRY);
-		QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_9(ha, "done\n");
 	}
 }
 
@@ -6374,7 +6727,7 @@
 	uint8_t			wwpn[EXT_DEF_WWN_NAME_SIZE];
 	ql_tgt_t		*tq;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	if (ddi_copyin((void *)(uintptr_t)cmd->RequestAdr,
 	    (void*)wwpn, sizeof (EXT_DEST_ADDR), mode) != 0) {
@@ -6386,7 +6739,7 @@
 
 	qlnt = QLNT_PORT;
 	name = wwpn;
-	QL_PRINT_9(CE_CONT, "(%d): wwpn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
+	QL_PRINT_9(ha, "wwpn=%02x%02x%02x%02x%02x%02x%02x%02x\n",
 	    ha->instance, name[0], name[1], name[2], name[3], name[4],
 	    name[5], name[6], name[7]);
 
@@ -6408,7 +6761,7 @@
 		cmd->ResponseLen = 0;
 	}
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -6438,13 +6791,10 @@
 	ql_fcache_t	*tail = NULL;
 	ql_fcache_t	*ftmp;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started cfg=0x%llx\n", ha->cfg_flags);
 
-	CACHE_LOCK(ha);
-
 	/* If we already have populated it, rtn */
 	if (ha->fcache != NULL) {
-		CACHE_UNLOCK(ha);
 		EL(ha, "buffer already populated\n");
 		return (QL_SUCCESS);
 	}
@@ -6452,7 +6802,6 @@
 	ql_flash_nvram_defaults(ha);
 
 	if ((rval = ql_setup_flash(ha)) != QL_SUCCESS) {
-		CACHE_UNLOCK(ha);
 		EL(ha, "unable to setup flash; rval=%xh\n", rval);
 		return (rval);
 	}
@@ -6475,7 +6824,7 @@
 
 		/* Do the firmware node first for 24xx/25xx's */
 		if (fw_done == 0) {
-			if (CFG_IST(ha, CFG_CTRL_24258081)) {
+			if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 				freadpos = ha->flash_fw_addr << 2;
 			}
 			fw_done = 1;
@@ -6510,9 +6859,8 @@
 		EL(ha, "failed, done\n");
 	} else {
 		ha->fcache = head;
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_10(ha, "done\n");
 	}
-	CACHE_UNLOCK(ha);
 
 	return (rval);
 }
@@ -6543,7 +6891,7 @@
 	ql_fcache_t	*tail = NULL;
 	ql_fcache_t	*ftmp;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	while (freadpos != 0xffffffff) {
 
@@ -6565,7 +6913,7 @@
 
 		/* Do the firmware node first for 24xx's */
 		if (fw_done == 0) {
-			if (CFG_IST(ha, CFG_CTRL_24258081)) {
+			if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 				freadpos = ha->flash_fw_addr << 2;
 			}
 			fw_done = 1;
@@ -6572,13 +6920,13 @@
 		}
 
 		/* read in first FBUFSIZE bytes of this flash section */
-		if (freadpos+FBUFSIZE > bsize) {
+		if (freadpos + FBUFSIZE > bsize) {
 			EL(ha, "passed buffer too small; fr=%xh, bsize=%xh\n",
 			    freadpos, bsize);
 			rval = QL_FUNCTION_FAILED;
 			break;
 		}
-		bcopy(bfp+freadpos, ftmp->buf, FBUFSIZE);
+		bcopy(bfp + freadpos, ftmp->buf, FBUFSIZE);
 
 		/* checkout the pci data / format */
 		if (ql_check_pci(ha, ftmp, &freadpos)) {
@@ -6598,12 +6946,10 @@
 		/*
 		 * Release previous fcache resources and update with new
 		 */
-		CACHE_LOCK(ha);
 		ql_fcache_rel(ha->fcache);
 		ha->fcache = head;
-		CACHE_UNLOCK(ha);
 
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 }
 
@@ -6691,7 +7037,7 @@
 	ql_link_t		*link;
 	ql_adapter_state_t	*ha2;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Get base path length. */
 	for (len = (uint32_t)strlen(ha->devpath); len; len--) {
@@ -6709,22 +7055,20 @@
 			continue;
 		}
 
-		CACHE_LOCK(ha2);
 		ql_fcache_rel(ha2->fcache);
 		ha2->fcache = NULL;
 
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			if (ha2->vcache != NULL) {
 				kmem_free(ha2->vcache, QL_24XX_VPD_SIZE);
 				ha2->vcache = NULL;
 			}
 		}
-		CACHE_UNLOCK(ha2);
 
 		(void) ql_setup_fcache(ha2);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -6784,7 +7128,7 @@
 	uint32_t	doff;
 	uint8_t		*pciinfo;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (fcache != NULL) {
 		pciinfo = fcache->buf;
@@ -6821,8 +7165,7 @@
 
 		*nextpos = 0xffffffff;
 
-		QL_PRINT_9(CE_CONT, "(%d): CFG_SBUS_CARD, done\n",
-		    ha->instance);
+		QL_PRINT_3(ha, "CFG_SBUS_CARD, done\n");
 
 		return (0);
 	}
@@ -6871,16 +7214,10 @@
 		    "%d.%02d.%02d", fcache->buf[19], fcache->buf[23],
 		    fcache->buf[27]);
 
-		if (CFG_IST(ha, CFG_CTRL_81XX)) {
-			*nextpos = 0x200000;
-		} else if (CFG_IST(ha, CFG_CTRL_8021)) {
-			*nextpos = 0x80000;
-		} else {
-			*nextpos = 0;
-		}
+		*nextpos = ha->boot_code_addr << 2;
 		kmem_free(buf, FBUFSIZE);
 
-		QL_PRINT_9(CE_CONT, "(%d): FTYPE_FW, done\n", ha->instance);
+		QL_PRINT_3(ha, "FTYPE_FW, done\n");
 
 		return (0);
 	}
@@ -6908,8 +7245,8 @@
 	}
 
 	if (pcid->indicator == PCI_IND_LAST_IMAGE) {
-		QL_PRINT_9(CE_CONT, "(%d): last image\n", ha->instance);
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		QL_PRINT_3(ha, "last image\n");
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			ql_flash_layout_table(ha, *nextpos +
 			    (pcid->imagelength[0] | (pcid->imagelength[1] <<
 			    8)) * PCI_SECTOR_SIZE);
@@ -6943,7 +7280,7 @@
 	(void) snprintf(fcache->verstr, FCHBA_OPTION_ROM_VERSION_LEN,
 	    "%d.%02d", pcid->revisionlevel[1], pcid->revisionlevel[0]);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (0);
 }
@@ -6968,7 +7305,7 @@
 	uint32_t	len, faddr, cnt;
 	uint16_t	chksum, w16;
 
-	QL_PRINT_9(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_9(ha, "started\n");
 
 	/* Process flash layout table header */
 	len = sizeof (ql_flt_ptr_t);
@@ -6993,7 +7330,8 @@
 	}
 	if (chksum != 0 || fptr->sig[0] != 'Q' || fptr->sig[1] != 'F' ||
 	    fptr->sig[2] != 'L' || fptr->sig[3] != 'T') {
-		EL(ha, "ptr chksum=%xh, sig=%c%c%c%c\n", chksum, fptr->sig[0],
+		EL(ha, "ptr chksum=%xh, sig=%c%c%c%c \n",
+		    chksum, fptr->sig[0],
 		    fptr->sig[1], fptr->sig[2], fptr->sig[3]);
 		kmem_free(bp, len);
 		return;
@@ -7005,7 +7343,7 @@
 
 	ql_process_flt(ha, faddr);
 
-	QL_PRINT_9(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_9(ha, "done\n");
 }
 
 /*
@@ -7029,7 +7367,7 @@
 	uint32_t	len, cnt, fe_addr;
 	uint16_t	chksum, w16;
 
-	QL_PRINT_9(CE_CONT, "(%d): started faddr=%xh\n", ha->instance, faddr);
+	QL_PRINT_9(ha, "started faddr=%xh\n", faddr);
 
 	/* Process flash layout table header */
 	if ((bp = kmem_zalloc(FLASH_LAYOUT_TABLE_SIZE, KM_SLEEP)) == NULL) {
@@ -7067,7 +7405,7 @@
 
 	/* Process Function/Port Configuration Map. */
 	nv_rg = vpd_rg = 0;
-	if (CFG_IST(ha, CFG_CTRL_8021)) {
+	if (CFG_IST(ha, CFG_CTRL_82XX)) {
 		uint16_t	i;
 		uint8_t		*mbp = eaddr;
 		ql_fp_cfg_map_t	*cmp = (ql_fp_cfg_map_t *)mbp;
